require 'spec_helper'

Klass = Class.new(FormLogic::Base) do
  property :mock_property1, :mock_property2, to: :mock 
  virtual  :stub_virtual1, :stub_virtual2
end

describe Klass do

  class Mock
    def mock_property1
      :mock_answer1
    end

    def mock_property2
      :mock_answer2
    end
  end

  subject { Klass.new(Mock.new) }
  
  describe 'properies' do
    it 'delegates property to an object' do
      expect(subject.mock_property1).to eq :mock_answer1
      expect(subject.mock_property2).to eq :mock_answer2
    end
  end

  describe 'virtuals' do
    it 'generates attr accessors' do
      %i( stub_virtual1 stub_virtual1= stub_virtual2 stub_virtual2=).each do |attr|
        expect(subject.class.method_defined?(attr)).to be true
      end
    end
  end
end
